import { Key, Selector, ServiceCollection } from './ServiceCollection';
import { IServiceProvider } from './ServiceProvider';
export declare type PropertyOf<E> = Required<{
    [key in keyof E]: key & Key<E>;
}>;
export declare const Services: <T = {}>() => ServiceCollection<T>;
export declare const propertyOf: <T>() => Required<{ [key in keyof T]: key & keyof T & string; }>;
export declare const proxyOf: <E>(self: IServiceProvider<E>) => E;
export declare function extractSelector<T, E>(options: Selector<T, E>): Key<E>;
